#include <iostream>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include <SDL2/SDL_ttf.h>
#include <SDL2/SDL_mixer.h>
#include <stdlib.h>
#include <fstream>
#include <string>
#include <sstream> 
#include <filesystem>
#define Maximum(a, b) ((a > b) ? a : b)
#define Minimum(a, b) ((a < b) ? a : b)


SDL_DisplayMode DMode;
SDL_Window* Window = NULL;
SDL_Renderer* Renderer = NULL; //mystic thing, brings an image to the screen
SDL_Surface* CurrentSurface = NULL;
SDL_Surface* ScreenSurface = NULL; 
SDL_Rect Reader;
SDL_Rect Writer;
SDL_Event event;
bool FullScreen=true;
bool AntiA=false;
bool running=true;
SDL_Texture *Tileset;
SDL_Texture *Digits;
SDL_Texture *GUI;
SDL_Texture *Shadow;
SDL_Texture *BG;
TTF_Font *gFont[5];
std::string speicher;
char* Layoutfile="";
int yCorr=0;
bool Fullrandom=false;
int GUIMode=1;

class CArr
{
	public:
	int r=0;
	int g=0;
	int b=0;
};

int CountColor=0;
CArr ACol[30];

int iniSDL()
{
	 if( SDL_Init( SDL_INIT_VIDEO ) < 0 ) { printf( "SDL konnte nicht initialisiert werden: %s\n", SDL_GetError() ); }
		else { 
		 if( !SDL_SetHint( SDL_HINT_RENDER_SCALE_QUALITY, "1" ) ) { printf( "Warning: Linear texture filtering not enabled!" ); }
		if(AntiA==true)
		{
		SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
		SDL_GL_SetAttribute(SDL_GL_MULTISAMPLEBUFFERS, 1);
	    SDL_GL_SetAttribute(SDL_GL_MULTISAMPLESAMPLES, 2);
		SDL_GL_SetAttribute(SDL_GL_ACCELERATED_VISUAL, 1);
		}
		  for(int i = 0; i < SDL_GetNumVideoDisplays(); ++i)
		{
		
		int should_be_zero = SDL_GetCurrentDisplayMode(i, &DMode);

		 if(should_be_zero != 0)
  	
 	    SDL_Log("SDL-Fehler bei der Ausgabe #%d: %s", i, SDL_GetError());

		 else
 	   

		
	   SDL_Log("Anzeige #%d: Modus: %dx%dpx @ %dhz. \n", i, DMode.w, DMode.h, DMode.refresh_rate);
		  }
 
		}
		
		
		if(FullScreen==true)
			  Window=SDL_CreateWindow("Mahjongg", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_FULLSCREEN | SDL_WINDOW_OPENGL ); 
		else
			Window=SDL_CreateWindow("Mahjongg", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, DMode.w, DMode.h, SDL_WINDOW_SHOWN | SDL_WINDOW_OPENGL | SDL_WINDOW_RESIZABLE ); 
		
		Renderer = SDL_CreateRenderer( Window, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC ); 
		    
		
		 SDL_RenderSetLogicalSize(Renderer, 1920, 1080);
		 ScreenSurface = SDL_GetWindowSurface( Window );
		if(FullScreen==true)
			SDL_SetWindowFullscreen(Window, SDL_WINDOW_FULLSCREEN);
//fonts
if( TTF_Init() == -1 ) { printf( "SDL_ttf could not initialize! SDL_ttf Error: %s\n", TTF_GetError() ); }	
//ini Sound!
 if( Mix_OpenAudio( 44100, MIX_DEFAULT_FORMAT, 2, 2048 ) < 0 ) { printf( "Ton-Wiedergabe nicht möglich :(: %s\n", Mix_GetError() );}
	Mix_AllocateChannels(48);

	 
     SDL_ShowCursor(1);
}

SDL_Texture* loadTexture( std::string path ) { 
	SDL_Texture* newTexture = NULL; 
		SDL_Surface* loadedSurface = IMG_Load( path.c_str() ); 
	if( loadedSurface == NULL ) { printf( "Unable to load image %s! SDL_image Error: %s\n", path.c_str(), IMG_GetError() ); } else { 
		newTexture = SDL_CreateTextureFromSurface( Renderer, loadedSurface ); if( newTexture == NULL ) { printf( "Unable to create texture from %s! SDL Error: %s\n", path.c_str(), SDL_GetError() ); } 
		
		SDL_FreeSurface( loadedSurface ); } return newTexture; }
		



class TextBox
{
	public:
	 int W=9000;
	 int H=100;
	 SDL_Texture *Tex;
	 std::string content="Textbox";
	 SDL_Color Farbe={ACol[2].r, ACol[2].g, ACol[2].b};
	 SDL_Color LFarbe={ACol[3].r, ACol[3].g, ACol[3].b};
	 SDL_Color BGColor={ACol[4].r, ACol[4].g, ACol[4].b};
	 bool ShowBg=false;
	 int Font=1;
		
		 int LFont=0;
		 std::string LString;
		  
	 int CalcMe()
	 {
		 
		 
		if(content!="" && (content!=LString || LFont!=Font || LFarbe.a!=Farbe.a || LFarbe.r!=Farbe.r || LFarbe.g!=Farbe.g || LFarbe.b!=Farbe.b))
		{
			LString=content;
			LFont=Font;
			LFarbe=Farbe;
			SDL_Surface* Result=NULL;
	
		

			Result=TTF_RenderText_Blended_Wrapped(gFont[Font], content.c_str(), Farbe, W);

			
		
			Tex=SDL_CreateTextureFromSurface(Renderer, Result);
			
			SDL_FreeSurface(Result);
		}
	 }
	 
	 int TextBoxRender(SDL_Renderer* Rend, int PosX, int PosY, int a=255)
	  {
		  SDL_Rect Wri;
				CalcMe();
	
				Wri.x=PosX;
				Wri.y=PosY;
				Wri.w=W;
				Wri.h=H;
				if(ShowBg==true)
				{
						  SDL_SetRenderDrawColor(Rend, BGColor.r, BGColor.b, BGColor.g, a);
							SDL_RenderFillRect(Rend, &Wri);
				}
				
				int w, h;
				SDL_QueryTexture(Tex, NULL, NULL, &w, &h);
				Wri.w=w;
				Wri.h=h;
				Wri.x=Wri.x+10;
				Wri.y=Wri.y+15;
				SDL_SetTextureAlphaMod(Tex, a);

				SDL_RenderCopyEx( Rend, Tex, NULL, &Wri, NULL, NULL, SDL_FLIP_NONE);
				 
	  }
};

TextBox TBoxes[50];

class Highscore
{
	public:
	int Score=0;
	std::string Name;
	TextBox TBox;
	
	int Render(SDL_Renderer* Rend, int x, int y, int a=255)
	{
		TBox.W=1300;
		TBox.H=90;
		TBox.content=Name;
		TBox.content.append("- -");
		TBox.content.append(std::to_string(Score));
		TBox.CalcMe();
		TBox.TextBoxRender(Rend, x, y, a);
	}
};	

Highscore Scorelist[12];

int CheckForHighscore(int Score)
{
	int r=0;
	for(int i=1; i<11; i++)
	{
		if(Score>=Scorelist[i].Score && r==0)r=i;
	}
	return r;
}

int loadScores() //Load the Player Archivment-State
	 {
			   
			int cScores=0;
			std::ifstream file;
	
			std::string str;
	
			file.open("Scores.txt");
			int HilfsInteger=0; 
			
			while (std::getline(file, str))
			{
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			if(speicher=="Name"){cScores++; Scorelist[cScores].Name=str;}
			if(speicher=="Score"){Scorelist[cScores].Score=atoi(str.c_str());}
		

										
				delete[] writable;
				speicher=str;
			}
		file.close();
		
		return 0;	
		}

int writeScores() //Save the made Archivements
	{
		  std::ofstream myfile;
		  myfile.open ("Scores.txt");
		  for(int i=1; i<11; i++)
		  {
		  myfile << "Name\n";
		  myfile << Scorelist[i].Name <<"\n";
		  myfile << "Score\n";
		  myfile << Scorelist[i].Score <<"\n";
		  }
		  myfile.close();
		  return 0;
		}

int WriteSettings()
{
  std::ofstream myfile;
  myfile.open ("Settings.txt");
  myfile << "AA\n";
  myfile << AntiA <<"\n";
  myfile << "Fullscreen\n";
  myfile << FullScreen <<"\n";
  myfile << "FullRandom\n";
  myfile << Fullrandom <<"\n";
  myfile << "GUIMode\n";
  myfile << GUIMode <<"\n";

for(int i=1; i<CountColor+1; i++)
	{
			myfile << "AddColor\n";
			myfile << i <<"\n";
			 myfile << "ColorR\n";
			myfile << ACol[i].r <<"\n";
			myfile << "ColorG\n";
			myfile << ACol[i].g <<"\n";
			myfile << "ColorB\n";
			myfile << ACol[i].b <<"\n";
	}
 
  myfile.close();
  return 0;
}


int EnterHighScore(int N, int Score, std::string Name)
{
	for(int i=11; i>N; i--)
	{
	 Scorelist[i]=Scorelist[i-1];	
	}
	Scorelist[N].Score=Score;
	Scorelist[N].Name=Name;
	
	writeScores();
}

std::string Paths[1000];
int Pathn=0;
int GetLayoutList()
{
	 std::string path = "layouts";
	 
    for (const auto & entry : std::filesystem::directory_iterator(path))
    {
		Pathn++;
        Paths[Pathn]=entry.path().string();
        //std::cout << Paths[Pathn] << std::endl;
	}

}

int DefTBoxes()
{
	int i=1;
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="No possible moves left. Continue or restart?";
	TBoxes[i].W=900;
	i++;
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Amazing! You did it! Continue or restart?";
	TBoxes[i].W=900;
	
	i++;
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Continue";
	TBoxes[i].W=900;
	TBoxes[i].H=100;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Restart";
	TBoxes[i].W=900;
	TBoxes[i].H=100;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Add highscore";
	TBoxes[i].W=900;
	TBoxes[i].H=100;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Name";
	TBoxes[i].Font=2;
	TBoxes[i].W=880;
	TBoxes[i].H=100;
	TBoxes[i].BGColor={200, 200, 200};
	TBoxes[i].ShowBg=false;
	
	i++;
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Continue";
	TBoxes[i].W=880;
	TBoxes[i].H=100;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++; //8 Playername
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="";
	TBoxes[i].W=880;
	TBoxes[i].H=100;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++; 
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Load";
	TBoxes[i].Font=2;
	TBoxes[i].W=880;
	TBoxes[i].H=100;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++; 
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="^";
	TBoxes[i].W=100;
	TBoxes[i].H=100;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	
	i++; 
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="v";
	TBoxes[i].W=100;
	TBoxes[i].H=100;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i=i+7; // 7 Slots for layouts
	
	i++; //19
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Back to game";
	TBoxes[i].W=1200;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Mode:";
	TBoxes[i].W=1200;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=false;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Fullscreen";
	TBoxes[i].W=590;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Window";
	TBoxes[i].W=590;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Randomness:";
	TBoxes[i].W=1200;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=false;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Possible";
	TBoxes[i].W=590;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Full";
	TBoxes[i].W=590;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="GUI:";
	TBoxes[i].W=1200;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=false;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="None";
	TBoxes[i].W=380;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Minimal";
	TBoxes[i].W=380;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Full";
	TBoxes[i].W=380;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Highscores";
	TBoxes[i].W=1200;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Load pattern";
	TBoxes[i].W=1200;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Help";
	TBoxes[i].W=1200;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=2;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="End game";
	TBoxes[i].W=1200;
	TBoxes[i].H=95;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=1;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="<";
	TBoxes[i].W=100;
	TBoxes[i].H=100;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
	
	i++;
	TBoxes[i].Font=3;
	TBoxes[i].Farbe={0, 0, 0};
	TBoxes[i].content="Gameplay: Click a time with your mouse to mark it. If a tile is marked, click another one to make both disappear and to acquire points. Empty the table of all tiles to get bonus point. \n \n Points: All tiles have base value of 20 which is multiplied with every tile of the same color (Man, Bamboo, Coin) that you pair after it (e.g. first pair of bamboo is 20 points, second pair 40, etc.). You can double the multiplier by pairing winds. Dragons give you 50 points (increased by your multiplier) but reduce the multiplier to zero. Seasons and flowers allow to both change color and keep the multiplier. All points are divided by the number of minutes between starting and finishing the table. \n \n Hotkeys: N Restart, H Help, U Back, L Layout, S Highscore,\n ESC Options";
	TBoxes[i].W=1920;
	TBoxes[i].H=1080;
	TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
	TBoxes[i].ShowBg=true;
}

int MMode=0;
int lM=0;
int MSave=0;

int A=0;
int ScrollStart=1;
int ShowMenu(int Mode, SDL_Renderer* Rend)
{
	int R=ACol[5].r;
	int B=ACol[5].g;
	int G=ACol[5].b;
	SDL_Rect Wri;
	if(lM!=Mode)
	{
		MSave=lM;
		lM=Mode;
		A=0;
		if(Mode==4){
		    TBoxes[8].content="";
			SDL_StartTextInput();
		}
	}
	if(A<255)A=A+10;
	if(A>255)A=255;


	if(Mode==1)
	{
		
		Wri.x=490;
		Wri.y=90;
		Wri.w=920;
		Wri.h=900;
		SDL_SetRenderDrawColor(Rend, R, B, G, A);
		SDL_RenderFillRect(Rend, &Wri);
				
		TBoxes[1].TextBoxRender(Rend, 500, 100, A);
		TBoxes[3].TextBoxRender(Rend, 500, 760, A);
		TBoxes[4].TextBoxRender(Rend, 500, 870, A);
		
	}
	if(Mode==2)
	{
		Wri.x=490;
		Wri.y=80;
		Wri.w=920;
		Wri.h=900;
		SDL_SetRenderDrawColor(Rend, R, B, G, A);
		SDL_RenderFillRect(Rend, &Wri);
		TBoxes[2].TextBoxRender(Rend, 500, 100, A);
		TBoxes[3].TextBoxRender(Rend, 500, 760, A);
		TBoxes[4].TextBoxRender(Rend, 500, 870, A);
		
	}
	if(Mode==3)
	{
		Wri.x=290;
		Wri.y=40;
		Wri.w=1300;
		Wri.h=1000;
		SDL_SetRenderDrawColor(Rend, R, B, G, A);
		SDL_RenderFillRect(Rend, &Wri);
		for(int i=1; i<11; i++)
		{
			Scorelist[i].Render(Rend, 300, 40+((i-1)*100), A);
		}
		TBoxes[34].TextBoxRender(Rend, 190, 940, A);
	}
	
	if(Mode==4)
	{
		Wri.x=490;
		Wri.y=390;
		Wri.w=900;
		Wri.h=300;
		SDL_SetRenderDrawColor(Rend, R, B, G, A);
		SDL_RenderFillRect(Rend, &Wri);
		TBoxes[6].TextBoxRender(Rend, 500, 380, A);
		TBoxes[7].TextBoxRender(Rend, 500, 580, A);
		
		TBoxes[8].TextBoxRender(Rend, 500, 480, A);
	}
	
		if(Mode==5)
	{
		Wri.x=200;
		Wri.y=100;
		Wri.w=1520;
		Wri.h=900;
		SDL_SetRenderDrawColor(Rend, R, B, G, A);
		SDL_RenderFillRect(Rend, &Wri);
		TBoxes[9].TextBoxRender(Rend, 200, 100, A);
		TBoxes[10].TextBoxRender(Rend, 1620, 100, A);
		TBoxes[11].TextBoxRender(Rend, 1620, 900, A);
		for(int i=12; i<19; i++)
		{
		if(Paths[ScrollStart+(i-12)]!="")
		{
		//TBoxes[i].BGColor={150, 150, 150};
		//if((ScrollStart+(i-12))%2==0)TBoxes[i].BGColor={175, 175, 175};
		
		TBoxes[i].W=1420;
		TBoxes[i].ShowBg=true;
		TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};
		TBoxes[i].Font=3;
		TBoxes[i].content=Paths[ScrollStart+(i-12)];
		TBoxes[i].TextBoxRender(Rend, 200, 200+(100*(i-12)), A);	
		}
		}
		TBoxes[34].TextBoxRender(Rend, 100, 900, A);
	}
	if(Mode==6)
	{
	Wri.x=360;
	Wri.y=95;
	Wri.w=1200;
	Wri.h=1080;	
		SDL_SetRenderDrawColor(Rend, R, B, G, A);
		SDL_RenderFillRect(Rend, &Wri);	
		
		TBoxes[19].TextBoxRender(Rend, 360, 0, A);
		TBoxes[20].TextBoxRender(Rend, 360, 100, A);
		TBoxes[21].TextBoxRender(Rend, 360, 200, A);
		TBoxes[22].TextBoxRender(Rend, 970, 200, A);
		if(FullScreen==true)
		{
		TBoxes[21].BGColor={93, 182, 130};
		TBoxes[22].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};		
		}
		if(FullScreen==false)
		{
		TBoxes[22].BGColor={93, 182, 130};	
		TBoxes[21].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};	
		}
		TBoxes[23].TextBoxRender(Rend, 360, 300, A);
		TBoxes[24].TextBoxRender(Rend, 360, 400, A);
		TBoxes[25].TextBoxRender(Rend, 970, 400, A);
		if(Fullrandom==false)
		{
		TBoxes[24].BGColor={93, 182, 130};
		TBoxes[25].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};	
		}
		if(Fullrandom==true)
		{
		TBoxes[25].BGColor={93, 182, 130};
		TBoxes[24].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};	
		}
		TBoxes[26].TextBoxRender(Rend, 360, 500, A);
		TBoxes[27].TextBoxRender(Rend, 360, 600, A);
		TBoxes[28].TextBoxRender(Rend, 770, 600, A);
		TBoxes[29].TextBoxRender(Rend, 1180, 600, A);
		for(int i=27; i<30; i++)
		{
			TBoxes[i].BGColor={ACol[4].r, ACol[4].b, ACol[4].g};	
			if(i-27==GUIMode)TBoxes[i].BGColor={93, 182, 130};
		}
		TBoxes[30].TextBoxRender(Rend, 360, 700, A);
		TBoxes[31].TextBoxRender(Rend, 360, 800, A);
		TBoxes[32].TextBoxRender(Rend, 360, 900, A);
		TBoxes[33].TextBoxRender(Rend, 360, 1000, A);
	}
	if(MMode==7)
	{
	 TBoxes[35].TextBoxRender(Rend, 0, 0, A);
	 TBoxes[34].TextBoxRender(Rend, 0, 980, A);
	}
}

int GUIAlpha[5];
int ShowGUI(SDL_Renderer* Rend)
{
	SDL_Rect Wri;
	SDL_Rect Rea;
	
	for(int i=0; i<5; i++)
	{
	Rea.x=0+(300*i);
	Rea.y=0;
	Rea.w=300;
	Rea.h=100;
	
	Wri=Rea;
	Wri.x=360+(i*300);	
	SDL_SetTextureAlphaMod(GUI, GUIAlpha[i]);
	 SDL_RenderCopyEx( Rend, GUI, &Rea, &Wri, NULL, NULL, SDL_FLIP_NONE);		
	}
	return 0;
}

int CheckGUI(int x, int y)
{
	int r=-1;
	for(int i=0; i<5; i++)
	{
		if((x>360+(i*300)) && (x<(360+(i*300)+300)) && y>0 && y<100)
		 r=i;
	}
	return r;
}
//Gamestuff:

class Stone
{
public:
 int ID=0;
 int Number=0;
 int Sprite=0;

 

};

class Klotz
{
	public:
	int Z;
	int X;
	int Y;
};

class Protocoll
{
	public:
	Klotz Position[3];
	Stone Tile[3];
	int Score;
	int Scorecolor=0;
    int Scoremulti=0;
	
};

class Timor
{
	public:
	int Minutes=0;
	int Seconds=0;
	int TotalSeconds=0;
	int Score=0;
	
	int RenderNumber(SDL_Renderer* Rend, int x, int y, int n, bool Scorer=false)
	{
	std::string s;
	s = std::to_string(n);	
	SDL_Rect targ;
	targ.x=x;
	targ.y=y;
	targ.w=25;
	targ.h=33;
	
	SDL_Rect read;
	read.x=0;
	read.y=0;
	read.w=25;
	read.h=33;
	
	if(Scorer==false)
	{
	if(s=="0")s="00";
	if(s=="1")s="01";
	if(s=="2")s="02";
	if(s=="3")s="03";
	if(s=="4")s="04";
	if(s=="5")s="05";
	if(s=="6")s="06";
	if(s=="7")s="07";
	if(s=="8")s="08";
	if(s=="9")s="09";
	}
	
	for(int i=0; i<s.length(); i++)
	{
		
		std::string a=s.substr (i,1);
		if(a=="-")
		{
		read.x=250;
		read.y=0;
		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		if(a=="0")
		{
		read.x=225;
		read.y=0;
		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		if(a=="1")
		{
		read.x=0;
		read.y=0;

		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		if(a=="2")
		{
		read.x=25;
		read.y=0;

		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		if(a=="3")
		{
		read.x=50;
		read.y=0;

		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		if(a=="4")
		{
		read.x=75;
		read.y=0;

		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		if(a=="5")
		{
		read.x=100;
		read.y=0;

		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		if(a=="6")
		{
		read.x=125;
		read.y=0;

		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		if(a=="7")
		{
		read.x=150;
		read.y=0;

		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		if(a=="8")
		{
		read.x=175;
		read.y=0;

		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		if(a=="9")
		{
		read.x=200;
		read.y=0;

		 SDL_RenderCopyEx( Rend, Digits, &read, &targ, NULL, NULL, SDL_FLIP_NONE);	
		}
		targ.x=targ.x+25;
	}
	return targ.x;	
	}
	
	int DrawTime(SDL_Renderer* Rend, int x, int y)
	{
	  int r=RenderNumber(Rend, x, y, Minutes);
	  SDL_Rect targ;
	  targ.x=r+10;
	  targ.y=y+5;
	  targ.w=3;
	  targ.h=23;
	  SDL_SetRenderDrawColor(Rend, ACol[6].r, ACol[6].g, ACol[6].b, 150);
	  SDL_RenderFillRect(Rend, &targ);	
	  RenderNumber(Rend, r+20, y, Seconds);
	  RenderNumber(Rend, x, y+40, Score, true);
	  return 0;
	}
 	
};

Timor Tim;
Protocoll History[500];
int hist=0;

int Scoreplace=0;
int EnteredScore=0;

class Table
{
public:
  Stone Layers[10][50][50]; //z, x, y
  Stone Layers2[10][50][50]; //z, x, y
  int SelectedStoneZ=0; 
  int SelectedStoneX=0; 
  int SelectedStoneY=0; 
  int X=500;
  int Y=150;
  
  bool Layercoloring=false;
  bool Tileframes=true;
  
  int Starttime=0;
  int Score=0;
  int Scorecolor=0;
  int Scoremulti=0;
  bool Fullrandom=false;
  
  Klotz Combolist[300];
  Klotz Combolist2[300];
  int FreeCombos=0;
  
  int Helptimer=0;
  Klotz Helper1;
  Klotz Helper2;
  

  
  bool StoneFree(int z, int x, int y)
  {
  bool r=true;
  if( Layers[z+1][x-1][y-1].ID!=0 || Layers[z+1][x-1][y+1].ID!=0|| Layers[z+1][x][y].ID!=0 ||  Layers[z+1][x+1][y-1].ID!=0 || Layers[z+1][x+1][y+1].ID!=0 || Layers[z+1][x+1][y].ID!=0  || Layers[z+1][x-1][y].ID!=0 || Layers[z+1][x][y+1].ID!=0  || Layers[z+1][x][y-1].ID!=0)r=false;
  bool LeftSide=true;
  bool RightSide=true;
 if(Layers[z][x-2][y].ID!=0 || Layers[z][x-2][y-1].ID!=0 || Layers[z][x-2][y+1].ID!=0)LeftSide=false;
  if(Layers[z][x+2][y].ID!=0 || Layers[z][x+2][y-1].ID!=0 || Layers[z][x+2][y+1].ID!=0)RightSide=false;
  if(RightSide==false && LeftSide==false)r=false;
  return r;
  
  }
  
    bool StoneFree2(int z, int x, int y)
  {
  bool r=true;
  if( Layers2[z+1][x-1][y-1].ID!=0 || Layers2[z+1][x-1][y+1].ID!=0|| Layers2[z+1][x][y].ID!=0 ||  Layers2[z+1][x+1][y-1].ID!=0 || Layers2[z+1][x+1][y+1].ID!=0 || Layers2[z+1][x+1][y].ID!=0  || Layers2[z+1][x-1][y].ID!=0 || Layers2[z+1][x][y+1].ID!=0  || Layers2[z+1][x][y-1].ID!=0)r=false;
  bool LeftSide=true;
  bool RightSide=true;
 if(Layers2[z][x-2][y].ID!=0 || Layers2[z][x-2][y-1].ID!=0 || Layers2[z][x-2][y+1].ID!=0)LeftSide=false;
  if(Layers2[z][x+2][y].ID!=0 || Layers2[z][x+2][y-1].ID!=0 || Layers2[z][x+2][y+1].ID!=0)RightSide=false;
  if(RightSide==false && LeftSide==false)r=false;
  return r;
  
  }
 
 int OpenLayout(char* path)
 {
	 
			std::ifstream file;
	
			std::string str;
		
			file.open(path);
			int HilfsInteger=0; 
			int Mode=0;
				int row=1;
				int line=1;
				int layer=1;
			    int counter=0;
			    
			    int mX=0;
			    int mY=0;
			    int mZ=0;
			    
			while (std::getline(file, str))
			{
			
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
				
			if(speicher[0]=='k'){Mode=1;}  //Kmahjongg
			else
			if(speicher[0]=='K'){Mode=2;} //Classic
		   	else
			if(speicher[0]=='m'){Mode=3;} //minimahjongg!
		    //std::cout << "Mode: " << Mode << std::endl;
		    if(Mode==1 && str[0]!='k')
		    {
			//std::cout << "Line detected." << std::endl;
				for(std::string::size_type i = 0; i < str.size(); ++i) 
				{ 
					//std::cout << str[i];
					if(str[i]=='.' || str[i]=='4' || str[i]=='3' || str[i]=='2'){Layers2[layer][row][line].ID=0; row++;}
					
					else if(str[i]=='1' && counter<144)
					{
					counter++;
					Layers2[layer][row][line].ID=1;
					row++;
						
					}
					
					
				}
				row=1;	
				line++;
					if(line==17)
					{
						line=1;
						layer++;
					}
					//std::cout << "Spaned " << counter << " Tiles " << std::endl;
				
			}
			if(Mode==2 && (str[0]=='0' || str[0]=='1'))
			{
				//std::cout << "Line detected.";
				for(std::string::size_type i = 0; i < str.size(); ++i) 
				{
					//std::cout << " Sign: " << str[i];
					if(str[i]=='1' || str[i]=='0')
					{
					if(str[i]=='1' && counter<144){Layers2[layer][row][line].ID=1; counter++;}
					row++;
					if(row==35)
					{
						line++;
						row=1;
					}
					if(line>18)Y=50;
					if(line==21)
					{
						row=1;
						line=1;
						layer++;
					}
					if(layer==9)i=str.size()+1;
					}
				}
		 
			}
			if(Mode==3) //Our Format!
			{
				if(speicher=="Z"){mZ=atoi(str.c_str());}
				if(speicher=="X"){mX=atoi(str.c_str());}
				if(speicher=="Y"){mY=atoi(str.c_str()); Layers2[mZ][mX][mY].ID=1; counter++;}
			}
			if(Mode==0 && (str[0]==' ' || str[0]=='\t')) //maybe xmahjongg?
			{
				//std::cout << "Line detected.";
				std::string Reader="";
				int Z=1;
				int X=1;
				int Y=1;
				int count=1;
				
				bool Ender=false;
				for(std::string::size_type i = 0; i < str.size(); ++i) 
				{
					if(str[i]==' ' || str[i]=='\t')
					{
					if(Ender==true)
					{
						//std::cout << Reader << std::endl;
						Ender=false;
						if(count==1)Y=atoi(Reader.c_str());
						if(count==2)X=atoi(Reader.c_str());
						if(count==3)Z=atoi(Reader.c_str());
						count++;
					}	
					}
					else
					{
						if(Ender==false)
						{
						Reader=str[i];
						Ender=true;
						}
						else
						{
						Reader.append(str, i, 1);
						}
					}
				}
				if(Ender==true)
					{
						//std::cout << Reader << std::endl;
						Ender=false;
						if(count==1)X=atoi(Reader.c_str());
						if(count==2)Y=atoi(Reader.c_str());
						if(count==3)Z=atoi(Reader.c_str());
						count++;
					}	
					if(count==4 && counter<144)
					{
					counter++;
					Layers2[Z+1][X+1][Y+1].ID=1;
					}
			}
			
										
				delete[] writable;
				speicher=str;
			}
		file.close();
	
		return 0;	
	 
 }
 
   int CheckForCombos()
  {
	 Klotz Freelist[150];
	 int FreeTiles=0;
	 int cTiles=0;
	 FreeCombos=0;
	 for(int Z=1; Z<10; Z++)
	   for(int X=1; X<50; X++)
	    for(int Y=1; Y<50; Y++)
	    {
		 if(Layers[Z][X][Y].ID!=0)
		 {
			 cTiles++;
			if(StoneFree(Z, X, Y)==true)
			{
			 FreeTiles++;
			 Freelist[FreeTiles].Z=Z;
			 Freelist[FreeTiles].X=X;
			 Freelist[FreeTiles].Y=Y;
			}
		 }
		}
		
		for(int i=1; i<FreeTiles+1; i++)
		{
			for(int i2=i; i2<FreeTiles+1; i2++)
			{
				if(Layers[Freelist[i].Z][Freelist[i].X][Freelist[i].Y].ID==Layers[Freelist[i2].Z][Freelist[i2].X][Freelist[i2].Y].ID && i!=i2)
				{
					//Combo Found
					FreeCombos++;
					Combolist[FreeCombos].Z=Freelist[i].Z;
					Combolist[FreeCombos].X=Freelist[i].X;
					Combolist[FreeCombos].Y=Freelist[i].Y;
					
					Combolist2[FreeCombos].Z=Freelist[i2].Z;
					Combolist2[FreeCombos].X=Freelist[i2].X;
					Combolist2[FreeCombos].Y=Freelist[i2].Y;
				}
			}
			
		}
	    if(cTiles==0){MMode=2; Score=Score+1000;}
		if(cTiles>0 && FreeTiles>0 && FreeCombos==0)MMode=1;
		
	   //std::cout << "There are " << FreeCombos << " Combos free." << std::endl;
  }
  
  
  
  int RenderStone(SDL_Renderer* Rend, int z, int x, int y, int m=0)
  {
	if(Layers[z][x][y].ID!=0)
	{
	SDL_Rect targ, read;
	if(m==0 || m==2)
	{
	targ.x=X+((x-1)*33)-(z*10);
	targ.y=Y+((y-1)*50)-(z*10);
	targ.w=76;
	targ.h=110;
	/*
	SDL_SetRenderDrawColor(Rend, 60, 60, 60, 255);
	SDL_RenderFillRect(Rend, &targ);
	*/
	SDL_RenderCopyEx( Rend, Shadow, NULL, &targ, NULL, NULL, SDL_FLIP_NONE);
	}	
	
	if(m==0 || m==1)
	{
	targ.x=X+((x-1)*33)-(z*10);
	targ.y=Y+((y-1)*50)-(z*10);
	targ.w=66;
	targ.h=100;
	
		
	read.x=100*((Layers[z][x][y].ID-1)+Layers[z][x][y].Number);
	read.y=0;
	read.w=100;
	read.h=150; 
	
	if(SelectedStoneZ==z && SelectedStoneX==x && SelectedStoneY==y)
	{
	SDL_SetRenderDrawColor(Rend, ACol[7].r, ACol[7].g, ACol[7].b, 255);
	
	}
	else
	{
	if(Layercoloring==true)
	{
	int C=190+(z*15);
	if(C>245)C=245;
	SDL_SetRenderDrawColor(Rend, C, C, C, 255);
	}
	else
	SDL_SetRenderDrawColor(Rend, ACol[8].r, ACol[8].g, ACol[8].b, 255);
	}
	if(Helptimer>0)
	{
		if((z==Helper1.Z && x==Helper1.X && y==Helper1.Y) || (z==Helper2.Z && x==Helper2.X && y==Helper2.Y)) 
		{
		 SDL_SetRenderDrawColor(Rend, ACol[9].r, ACol[10].g, ACol[10].b, 255);	
		}
		
	}
	SDL_RenderFillRect(Rend, &targ);
	SDL_RenderCopyEx( Rend, Tileset, &read, &targ, NULL, NULL, SDL_FLIP_NONE);
	SDL_SetRenderDrawColor(Rend, ACol[10].r, ACol[10].g, ACol[10].b, 255);	
	SDL_RenderDrawRect(Rend, &targ);
	
	if(Tileframes==true)
	{
		SDL_SetRenderDrawColor(Rend, ACol[11].r, ACol[11].g, ACol[11].b, 180);	
		SDL_Rect targ2;
		targ2.x=targ.x;
		targ2.y=targ.y;
		targ2.w=3;
		targ2.h=targ.h;
		SDL_RenderFillRect(Rend, &targ2);
		
	
		targ2.x=targ.x+targ.w-3;
		targ2.y=targ.y;
		targ2.w=3;
		targ2.h=targ.h;
		SDL_RenderFillRect(Rend, &targ2);
		
		targ2.x=targ.x;
		targ2.y=targ.y;
		targ2.w=targ.w;
		targ2.h=3;
		SDL_RenderFillRect(Rend, &targ2);
		
		targ2.x=targ.x;
		targ2.y=targ.y+targ.h-3;
		targ2.w=targ.w;
		targ2.h=3;
		SDL_RenderFillRect(Rend, &targ2);
		
	}
	
	} 
	} 
  }
  
  int Help()
  {
	  CheckForCombos();
	  if(FreeCombos>0)
	  {
		int picker=1+(rand()%FreeCombos);
		Helper1=Combolist[picker];
		Helper2=Combolist2[picker];
		Helptimer=100;
		Score=Score-100;
		for(int i=1; i<hist+1; i++)
		{
			History[i].Score=History[i].Score-100;
		}  
		  
	  }
  }
  
  int RenderBoard(SDL_Renderer* Rend)
  {
	  for(int Z=1; Z<10; Z++)
	  {
		  
	   for(int Y=1; Y<50; Y++)
	   for(int X=1; X<50; X++)
	     RenderStone(Rend, Z, X, Y, 2);
	     
	   for(int Y=1; Y<50; Y++)
	   for(int X=1; X<50; X++)
	     RenderStone(Rend, Z, X, Y, 1);
	 }
	  
  }
  
  Timor CalcTime()
  {
	if(Helptimer>0)
	Helptimer=Helptimer-1;
	Timor r;
	int aTime=SDL_GetTicks()-Starttime;
	r.Seconds=std::floor(aTime/1000);
	r.TotalSeconds=r.Seconds;
	r.Minutes=std::floor(r.Seconds/60);
	r.Seconds=r.Seconds-(r.Minutes*60);
	r.Score=Score;
	//std::cout << "The time is " << r.Minutes << " Minutes and " << r.Seconds << " Seconds." << std::endl;
	return r;
	  
  }
  
  int ClearTable()
  {
	  for(int Z=1; Z<10; Z++)
	   for(int X=1; X<50; X++)
	    for(int Y=1; Y<50; Y++)
	    {
			Layers[Z][X][Y].ID=0;
			Layers[Z][X][Y].Number=0;
		}
  }
  
  int FillTable()
  {
	  //Check for Highscore
	  if(Score!=0)
	  {
		  int Cherker=CheckForHighscore(Score);
		  if(Cherker>0)
		  {
			  Scoreplace=Cherker;
			  EnteredScore=Score;
			  MMode=4;
		  }
		  Score=0;
	  }
	  if(Score==0 && MMode==0)
	  {
	  //End
	  ClearTable();
	  	 bool finished=false;
	  	 int counter=0;
	  while(finished==false)
	  {
		counter++;
	  //Make the form
	  if(Layoutfile=="" || counter>=100)
	  {
	  //Layer 1
		 for(int i=4; i<28; i=i+2)
		  Layers2[1][i][1].ID=1;
		 for(int i=8; i<24; i=i+2)
		 Layers2[1][i][3].ID=1;
		 for(int i=6; i<26; i=i+2)
		 Layers2[1][i][5].ID=1;
		 for(int i=4; i<28; i=i+2)
		 Layers2[1][i][7].ID=1;
		 
		 Layers2[1][2][8].ID=1;
		 Layers2[1][28][8].ID=1;
		 Layers2[1][30][8].ID=1;
		 
		 for(int i=4; i<28; i=i+2)
		 Layers2[1][i][9].ID=1;
		 for(int i=6; i<26; i=i+2)
		 Layers2[1][i][11].ID=1;
		 for(int i=8; i<24; i=i+2)
		 Layers2[1][i][13].ID=1;
		 for(int i=4; i<28; i=i+2)
		 Layers2[1][i][15].ID=1;
		 
	
	 //Layer 2
	 for(int i=10; i<22; i=i+2)
	  for(int i2=3; i2<15; i2=i2+2)
	    Layers2[2][i][i2].ID=1;
	 //Layer 3
	  
	  for(int i=12; i<20; i=i+2)
	  for(int i2=5; i2<13; i2=i2+2)
	    Layers2[3][i][i2].ID=1;
	    
	 //Layer 4
	 for(int i=14; i<18; i=i+2)
	  for(int i2=7; i2<11; i2=i2+2)
	    Layers2[4][i][i2].ID=1;
	 
	 //Layer 5
	 Layers2[5][15][8].ID=1;
	}
	else
	{
	 OpenLayout(Layoutfile);	
	}	
	  //Check the second stack for free tiles!
	

    if(Fullrandom==false)
    {

	   bool building=true;
	   		 int SetArray[43];
	  for(int i=1; i<43; i++)
	   SetArray[i]=4;
	  while(building==true)
	  {

	  int freetiles=0;
	  Klotz Tilelist[500];
	  for(int Zc=9; Zc>0; Zc--)
	   for(int Xc=49; Xc>0; Xc--)
	    for(int Yc=49; Yc>0; Yc--)
	    {
			if(Layers2[Zc][Xc][Yc].ID==1)
			{
			if(StoneFree2(Zc, Xc, Yc)==true)
			{
			freetiles++;	
			Tilelist[freetiles].X=Xc;
			Tilelist[freetiles].Y=Yc;
			Tilelist[freetiles].Z=Zc;
			}
			}
			
		}
		//std::cout << "Free Tiles: " << freetiles << std::endl;
		
		if(freetiles>1)
		{
		//pick a color:
		bool picked=false;
		int p;
		while(picked==false)
		{
			p=1+rand()%36;
			if(SetArray[p]>0)
			{
				picked=true;
				SetArray[p]=SetArray[p]-2;
				//std::cout << "Searching";
			}
		}
		//set 2 tiles on the mainstack, remove from second stack
		int a=1+(rand()%(freetiles));
		Layers[Tilelist[a].Z][Tilelist[a].X][Tilelist[a].Y].ID=p;
		Layers2[Tilelist[a].Z][Tilelist[a].X][Tilelist[a].Y].ID=0;
		bool pickagain=true;
		int b=0;
		while(pickagain==true)
		{
		 b=1+((rand()%(freetiles)));
		 if(b!=a)pickagain=false;	
		}
	    Layers[Tilelist[b].Z][Tilelist[b].X][Tilelist[b].Y].ID=p;
		Layers2[Tilelist[b].Z][Tilelist[b].X][Tilelist[b].Y].ID=0;
		}
		if(freetiles==1)
		 building=false;
		if(freetiles==0)
		{
			finished=true;
			building=false;
		}
		}
		}
		if(Fullrandom==true)
		{
			bool Building=true;
			int SetArray[43];
			int APointer=0;
			  for(int i=1; i<43; i++)
			   SetArray[i]=4;
			 while(Building==true)
			 {
				 
				int freetiles=0;
				Klotz Tilelist[500];
				for(int Zc=9; Zc>0; Zc--)
				   for(int Xc=49; Xc>0; Xc--)
					for(int Yc=49; Yc>0; Yc--)
					{
						if(Layers2[Zc][Xc][Yc].ID==1)
						{
						
						freetiles++;	
						Tilelist[freetiles].X=Xc;
						Tilelist[freetiles].Y=Yc;
						Tilelist[freetiles].Z=Zc;
						
						}
			
					} 
					//std::cout << "Building. Free Tiles: " << freetiles << std::endl;
				//Pick a random tile:
				if(freetiles>0)
				{
				int pick=1+(rand()%freetiles);
				if(SetArray[APointer]>0)
				{
					Layers[Tilelist[pick].Z][Tilelist[pick].X][Tilelist[pick].Y].ID=APointer;
					Layers2[Tilelist[pick].Z][Tilelist[pick].X][Tilelist[pick].Y].ID=0;
					SetArray[APointer]--;
				}
				else APointer++;
				}
				if(freetiles==0)
				{
									 Building=false;
									 finished=true;
				}
			 }
			
		}
		}
		 int Seasons=0;
		 int Flowers=0;
		 for(int Zc=9; Zc>0; Zc--)
			for(int Xc=49; Xc>0; Xc--)
				for(int Yc=49; Yc>0; Yc--)
				{
					if(Layers[Zc][Xc][Yc].ID==35)
					{
						Layers[Zc][Xc][Yc].Number=Seasons;
						Seasons++;
					}
					if(Layers[Zc][Xc][Yc].ID==36)
					{
						Layers[Zc][Xc][Yc].ID=39;
						Layers[Zc][Xc][Yc].Number=Flowers;
						Flowers++;
					}		
				}
				
		Starttime=SDL_GetTicks();
		Score=0;
		Scorecolor=0;
		Scoremulti=0;
		Helptimer=0;
		SelectedStoneZ=0;
		SelectedStoneX=0;
		SelectedStoneY=0;
		hist=0;
		CheckForCombos();
	}
  }
  
  float AddScore(int Color)
  {
	float r=0; //Returner
	int Type=0;
	float ScoreMod=(float)((SDL_GetTicks()-Starttime)/1000)/60;
	if(ScoreMod<0.5)ScoreMod=0.5;
	if(Color>0 && Color<10) //man
	 Type=1;
	if(Color>9 && Color<19) //circle
	 Type=2;
	if(Color>18 && Color<28) //bamboo
	 Type=3;
	if(Color>27 && Color<32) //Winds
	 Type=4;
	if(Color>31 && Color<35) //Dragons
	 Type=5;
	if(Color==35)			//Seasons
	 Type=6;
	if(Color==39)			//Flowers
	 Type=7;
	 

	 
	 //std::cout << "Type is " << Type << std::endl;
	 if(Type==Scorecolor || Scorecolor==6 || Scorecolor==7) //If the Color is equal to the color before, increase the multiplier!
	 {
	 		 	
	 
	  Scoremulti=Scoremulti+1;
	  if(Type<4)
	  Scorecolor=Type;
	  r=20*Scoremulti;
	  // std::cout << "Normal Tile, Type: " << Type << "Multi increased, adds: " << r << std::endl;
	  
	   
	  
	}
	 if(Type<4 && Type!=Scorecolor) //If it is a normal tile and not the current color, reset the multi and set the new color
	 {
		Scoremulti=1;
		Scorecolor=Type;
		r=20*Scoremulti;
		 //std::cout << "Normal Tile, Type: " << Type << "Combobreaker, adds: " << r << std::endl;
		 
		 			
	 }
	 
	 if(Type==4)  //If it is a wind, double the multiplier
	 {
	  Scoremulti=Scoremulti*2;
	 // std::cout << "Wind, new multi: " << Scoremulti << std::endl;
	  
	  		
	 }
	 
	 //Play the sound
			 int s=1;
			 if(Scoremulti>0)s=Scoremulti;
			 if(s>14)s=14;
		
	 
	 if(Type==5) //If it is a dragon, give big points and reset the multiplier
	  {
		r=50*Scoremulti;
		//std::cout << "Dragon, reset multi, Adds " << r << std::endl;
		Scoremulti=0;
		Scorecolor=0;  
	  }
	  if(Type>5) //if it is a season or a flower, set the color to that
	  {
		  Scoremulti=Scoremulti+1;
		  Scorecolor=Type;
		 // std::cout << "Season/Flower. Joker." << std::endl;
	  }
	  r=r/ScoreMod;
	  //std::cout << "Multi " << Scoremulti << " Mod: " << ScoreMod << " Add: " << r << std::endl;
	  
	  return r;
  }
  
  int Click(int x, int y)
  {
	  
	 x=x-X;
	 y=y-Y;
	  
	  for(int Zc=9; Zc>0; Zc--)
	   for(int Xc=49; Xc>0; Xc--)
	    for(int Yc=49; Yc>0; Yc--)
	    {
		if(Layers[Zc][Xc][Yc].ID!=0)
		{
		if(StoneFree(Zc, Xc, Yc)==true)
		{
		SDL_Rect targ;
		targ.x=((Xc-1)*33)-(Zc*10);
		targ.y=((Yc-1)*50)-(Zc*10);
		targ.w=66;
		targ.h=100;
		
		if(x>targ.x && x<targ.x+targ.w && y>targ.y && y<targ.y+targ.h)
		{
			//treffer
		//Deactivate Helptimer
			Helptimer=0;
		if(SelectedStoneX==Xc && SelectedStoneY==Yc && SelectedStoneZ==Zc)
		{
		     SelectedStoneX=0;
			 SelectedStoneY=0;
			 SelectedStoneZ=0;
		}
		else
		{
		if(Layers[Zc][Xc][Yc].ID==Layers[SelectedStoneZ][SelectedStoneX][SelectedStoneY].ID)
		 {
			 

			 
			 hist++;
			 //Do scoring + history
			 History[hist].Scorecolor=Scorecolor;
			 History[hist].Scoremulti=Scoremulti;
			 History[hist].Score=Score;
			 int aScore=AddScore(Layers[Zc][Xc][Yc].ID);
			 Score=Score+aScore;
			 //Do history
			 
			 
			
			 
			 History[hist].Position[1].Z=Zc;
			 History[hist].Position[1].X=Xc;
			 History[hist].Position[1].Y=Yc;
			 History[hist].Tile[1]=Layers[Zc][Xc][Yc];
			 History[hist].Position[2].Z=SelectedStoneZ;
			 History[hist].Position[2].X=SelectedStoneX;
			 History[hist].Position[2].Y=SelectedStoneY;
			 History[hist].Tile[2]=Layers[SelectedStoneZ][SelectedStoneX][SelectedStoneY];
			
			 //Kill the stones!
			 Layers[Zc][Xc][Yc].ID=0;
			 Layers[SelectedStoneZ][SelectedStoneX][SelectedStoneY].ID=0;
			 SelectedStoneX=0;
			 SelectedStoneY=0;
			 SelectedStoneZ=0;
			 
			 CheckForCombos();
			 
		
		 }
		if((SelectedStoneX==0 && SelectedStoneY==0 && SelectedStoneZ==0) || Layers[Zc][Xc][Yc].ID!=Layers[SelectedStoneZ][SelectedStoneX][SelectedStoneY].ID)
		{	
			 SelectedStoneZ=Zc; 
			 SelectedStoneX=Xc; 
			 SelectedStoneY=Yc;
		 }
		 Zc=0;
		 Xc=0;
		 Yc=0;
		}
		}
		}
		}
		}
	  
  }

};

Table GameTable;

int RenderScreen()
{
	SDL_SetRenderDrawColor(Renderer, ACol[1].r, ACol[1].g, ACol[1].b, 255);
	SDL_RenderClear( Renderer );
	SDL_SetRenderDrawColor(Renderer, ACol[1].r, ACol[1].g, ACol[1].b, 255);
	SDL_Rect fill;
	fill.x=0;
	fill.y=0;
	fill.w=1920;
	fill.h=1080;
	SDL_RenderFillRect(Renderer, &fill);
	SDL_RenderCopyEx( Renderer, BG, NULL, &fill, NULL, NULL, SDL_FLIP_NONE);
	if(GUIMode>0)
	Tim.DrawTime(Renderer, 1750, 50);
	if(GUIMode>1)
		ShowGUI(Renderer);
	GameTable.RenderBoard(Renderer);
	ShowMenu(MMode, Renderer);
	SDL_RenderPresent( Renderer );
}

int ClickMenu(int x, int y)
{
if(MMode==1 || MMode==2)
{
	if(x>500 && x<1400 && y>760 && y<860)
	{
		MMode=0;
	}
	
		if(x>500 && x<1400 && y>870 && y<970)
	{
		MMode=0;
		GameTable.FillTable();
	}
	
}	
if(MMode==3)
{
	if(x>190 && x<290 && y>940 && y<1040)MMode=MSave;
}
if(MMode==4)
{
	if(x>500 && x<1380 && y>580 && y<680)
	{
	EnterHighScore(Scoreplace, EnteredScore, TBoxes[8].content);
	MMode=0;
	SDL_StopTextInput();
	GameTable.Score=0;
	GameTable.FillTable();
	}
}	
if(MMode==5)
{

	if(x>1620 && x<1720 && y>100 && y<200)
	{
		if(ScrollStart>1)ScrollStart--;
	}
	if(x>1620 && x<1720 && y>900 && y<1000)
	{
		if(ScrollStart<902)ScrollStart++;
	}	
	if(x>200 && x<1620 && y>200 && y<900)
	{
	
		int Picker=ScrollStart+(std::floor((y-200)/100));
		char *cstr = new char[Paths[Picker].length() + 1];
		strcpy(cstr, Paths[Picker].c_str());
		Layoutfile=cstr;
		//std::cout << " Selected " << Picker << " loading. " << std::endl;
		MMode=0;
		GameTable.FillTable();
	}	
	
	if(x>100 && x<200 && y>900 && y<1000)MMode=MSave;
}
if(MMode==6)
{
	if(x>360 && x<1570 && y>0 && y<100)
	 MMode=0;
    if(x>360 && x<960 && y>200 && y<300)
    {
	if(FullScreen==false)
	{
		
		SDL_SetWindowFullscreen(Window, SDL_WINDOW_SHOWN | SDL_WINDOW_FULLSCREEN | SDL_WINDOW_OPENGL ); 
		SDL_SetWindowDisplayMode(Window, &DMode);

	 }
	 FullScreen=true;
	 WriteSettings();
	 
		
			
	}
	 if(x>970 && x<1570 && y>200 && y<300)
	 {
	 if(FullScreen==true)
	 {
		 SDL_SetWindowFullscreen(Window,  SDL_WINDOW_SHOWN | SDL_WINDOW_OPENGL | SDL_WINDOW_RESIZABLE ); 
		 SDL_SetWindowResizable(Window, SDL_TRUE);

	 }
	 FullScreen=false;
	 WriteSettings();
	 }
	   if(x>360 && x<960 && y>400 && y<500)
	   {
			Fullrandom=false;
			GameTable.Fullrandom=false;
			WriteSettings();
		}
	 if(x>970 && x<1570 && y>400 && y<500)
	 {
	 Fullrandom=true;
	 GameTable.Fullrandom=true;
	}
	if(x>360 && x<1570 && y>600 && y<700)
	   {
			GUIMode=std::floor((x-360)/400);
			WriteSettings();
		}
		if(x>360 && x<1570 && y>700 && y<800)
	   {
			MMode=3;
		}
	if(x>360 && x<1570 && y>800 && y<900)
	   {
			MMode=5;
		}
		if(x>360 && x<1570 && y>900 && y<1000)
	   {
			MMode=7;
		}
	if(x>360 && x<1570 && y>1000 && y<1080)
	   {
			running=false;
		}
}
if(MMode==7 && x>0 && x<100 && y>980 && y<1080)MMode=MSave;
}

int LastClick=0;
int Events()
{
//Mouseman

		 int Mx1;
		 int My1;
		 int out=0;
		 int returner=0;
		 float xrel=0;
		 float yrel=0;
		 SDL_DisplayMode DM;
		 int gx, gy;
		 float offsetterY;
		 float offsetterX;
		 
		 //Adjact X/Y-Values to logical Rendersize

		
		SDL_GetWindowSize(Window, &DM.w,  &DM.h);
		SDL_RenderGetLogicalSize(Renderer, &gx, &gy);
			
		
		float DMH=DM.h;
		float DMW=DM.w;
		float GX=gx;
		float GY=gy;
		int Mx=0;
		int My=0;
		if(FullScreen==true)
		{
		offsetterY=(float)((DMH-((DMW/GX)*GY))/2);
		offsetterX=(float)((DMW-((DMH/GY)*GX))/2);
		
		if(offsetterX<offsetterY)offsetterX=0;
		else offsetterY=0;
		
		//std::cout << "OffsetterX: " << offsetterX << " Offsetter Y: " << offsetterY << std::endl;
		xrel=(float)GX/(DMW-(offsetterX*2));
		yrel=(float)GY/(DMH-(offsetterY*2));
		
		
		 SDL_GetMouseState(&Mx1, &My1); //Get Mouse State,
		 
		  //Adjact to Logical Rendersize
		  Mx=(Mx1-offsetterX)*xrel;
		  My=(My1-offsetterY)*yrel;	
		 }
		  
		  if(FullScreen==false) //no fullscreen?
		  {
			
			 float ratio=(float)DM.w/DM.h;
			 float nRatio=(float)1920/1080;
			 float Factor=0;
			 int mW=0;
			 int mH=0;
			  //std::cout << "Windowed. Ratio: " << ratio << " ";
			 if(ratio<nRatio)
			 {
				// std::cout << "Thinner than original."; 
				 //getting hight
				 float weidth=DM.w;
				 float adaptor=weidth/GX;
				 Factor=adaptor;
				 float height=GY*adaptor;
				 //std::cout << height << " ";
				 mH=(DM.h-height)/2;
				 //std::cout << " need to remove " << mH << " ";
			 }
			 if(ratio>nRatio) 
			 {
				 //std::cout << "Fatter than original";
				 float height=DM.h;
				 float adaptor=height/GY;
				 Factor=adaptor;
				 float weidth=GX*adaptor;
				 //std::cout << weidth << " ";
				 mW=(DM.w-weidth)/2;
				 //std::cout << " need to remove " << mW << " ";
			 }
			 SDL_GetMouseState(&Mx1, &My1);
			 Mx=((Mx1)-mW)/Factor;
			 My=((My1)-mH)/Factor;
			 //std::cout << std::endl;
		  }
		  
	
		 for(int i=0; i<5; i++)
		 {
		 int c=(CheckGUI(Mx, My));
		 if(c==i)
		 {
			 if(GUIAlpha[CheckGUI(Mx, My)]<250)
			 GUIAlpha[CheckGUI(Mx, My)]=GUIAlpha[CheckGUI(Mx, My)]+5;
		 }
		 else
		 GUIAlpha[i]=150;
		}
		  //if Button is pressed:
		  
		  if(SDL_GetMouseState(&Mx1, &My1) & SDL_BUTTON(SDL_BUTTON_LEFT))
		  {
			  if(LastClick<=0)
			  {
			  //do nothing :)
			  bool hitter=false;
			  if(GUIMode>1 && MMode==0)
			  {
				 int c=CheckGUI(Mx, My);
				 if(c==0)
				  {
					  if(hist>0)
						{
							GameTable.Layers[History[hist].Position[1].Z][History[hist].Position[1].X][History[hist].Position[1].Y]=History[hist].Tile[1];
							GameTable.Layers[History[hist].Position[2].Z][History[hist].Position[2].X][History[hist].Position[2].Y]=History[hist].Tile[2];
							GameTable.Score=History[hist].Score;
							GameTable.Scorecolor=History[hist].Scorecolor;
							GameTable.Scoremulti=History[hist].Scoremulti;
							hist--;
							GameTable.CheckForCombos();
						}
					}
				 if(c==1)GameTable.Help();
				 if(c==2)GameTable.FillTable();
				 if(c==3){MMode=6; hitter=true;}
				  
			  }
			  
			  LastClick=3;
			  if(hitter==false)ClickMenu(Mx, My);
			  if(MMode==0)
			  GameTable.Click(Mx, My);
			  //std::cout << "Click X: " << Mx << " Y: " << My << std::endl;
			 }
			  
		  }
		  else
		  {
			  if(LastClick>0)LastClick--;
		  }

//Mouseman end
while( SDL_PollEvent( &event ) ){
switch( event.type ){
      case SDL_KEYDOWN:
      {
		if(event.key.keysym.sym==SDLK_ESCAPE)
			{
				if(MMode==6)
				 running=false;
				MMode=6;
			} 
			if(event.key.keysym.sym==SDLK_BACKSPACE)
			{
			if(MMode==4)
			{	
				if(TBoxes[8].content.size()>0)
				TBoxes[8].content=TBoxes[8].content.substr(0, TBoxes[8].content.size()-1);
			}
			}
			if(event.key.keysym.sym==SDLK_RETURN)
			{
			if(MMode==4)
			{	
				EnterHighScore(Scoreplace, EnteredScore, TBoxes[8].content);
				MMode=0;
				SDL_StopTextInput();
				GameTable.Score=0;
				GameTable.FillTable();
			}
			}  
			if(MMode!=4)
			{
			if(event.key.keysym.sym==SDLK_u)
			{
				if(hist>0)
				{
					GameTable.Layers[History[hist].Position[1].Z][History[hist].Position[1].X][History[hist].Position[1].Y]=History[hist].Tile[1];
					GameTable.Layers[History[hist].Position[2].Z][History[hist].Position[2].X][History[hist].Position[2].Y]=History[hist].Tile[2];
					GameTable.Score=History[hist].Score;
					GameTable.Scorecolor=History[hist].Scorecolor;
					GameTable.Scoremulti=History[hist].Scoremulti;
					hist--;
					GameTable.CheckForCombos();
				}
			} 
			if(event.key.keysym.sym==SDLK_h)
			{
			 GameTable.Help();
			  //Cheat
			  /*
			   GameTable.Layers[GameTable.Helper1.Z][GameTable.Helper1.X][GameTable.Helper1.Y].ID=0;
			   GameTable.Layers[GameTable.Helper2.Z][GameTable.Helper2.X][GameTable.Helper2.Y].ID=0;
			   GameTable.CheckForCombos();
			   */
			}
			if(event.key.keysym.sym==SDLK_l)
			{
			 MMode=5;
			  //Cheat
			  /*
			   GameTable.Layers[GameTable.Helper1.Z][GameTable.Helper1.X][GameTable.Helper1.Y].ID=0;
			   GameTable.Layers[GameTable.Helper2.Z][GameTable.Helper2.X][GameTable.Helper2.Y].ID=0;
			   GameTable.CheckForCombos();
			   */
			}
			if(event.key.keysym.sym==SDLK_s)
			{
			 if(MMode==0)MMode=3;
			 else MMode=0;
			  //Cheat
			  /*
			   GameTable.Layers[GameTable.Helper1.Z][GameTable.Helper1.X][GameTable.Helper1.Y].ID=0;
			   GameTable.Layers[GameTable.Helper2.Z][GameTable.Helper2.X][GameTable.Helper2.Y].ID=0;
			   GameTable.CheckForCombos();
			   */
			}
			if(event.key.keysym.sym==SDLK_n)
			 GameTable.FillTable();
			}	  }
	  break;
	  case SDL_TEXTINPUT:
	  {
		 if(MMode==4)
		 TBoxes[8].content+=event.text.text;
	  }
	  break;
	  case SDL_WINDOWEVENT:
	  {
	  if(event.window.event==SDL_WINDOWEVENT_CLOSE)running=false;
	  }
	  break;
	}	
}
}

int loadSettings(char* mainfile)
{
			std::ifstream file;
	
			std::string str;
	
			file.open(mainfile);
			int HilfsInteger=0; 
			int HilfsInteger2=0; 
			while (std::getline(file, str))
			{
			char * writable = new char[str.size() + 1];
			std::copy(str.begin(), str.end(), writable);
			writable[str.size()] = '\0';
			if(speicher=="Fullscreen"){FullScreen=atoi(str.c_str());}
			if(speicher=="AA"){AntiA=atoi(str.c_str());}
			if(speicher=="FullRandom"){Fullrandom=atoi(str.c_str());}
			if(speicher=="GUIMode"){GUIMode=atoi(str.c_str());}
			if(speicher=="AddColor"){CountColor++;}
			if(speicher=="ColorR"){ACol[CountColor].r=atoi(str.c_str());}
			if(speicher=="ColorG"){ACol[CountColor].g=atoi(str.c_str());}						
			if(speicher=="ColorB"){ACol[CountColor].b=atoi(str.c_str());}
				delete[] writable;
				speicher=str;
			}
		file.close();	
}



int main()
{
std::cout << "Hi"; 
loadSettings("Settings.txt");
GameTable.Fullrandom=Fullrandom;
iniSDL();
srand (time(NULL));
Tileset=loadTexture("tiles.png");
Digits=loadTexture("digits.png");
GUI=loadTexture("GUI.png");
Shadow=loadTexture("Shadow.png");
BG=loadTexture("bg.png");
gFont[1]=TTF_OpenFont( "montserrat/Montserrat-Regular.ttf", 126 );
gFont[2]=TTF_OpenFont( "montserrat/Montserrat-Regular.ttf", 80 );
gFont[3]=TTF_OpenFont( "montserrat/Montserrat-Regular.ttf", 60 );


DefTBoxes();
GameTable.FillTable();
loadScores();
GetLayoutList();
	SDL_SetRenderDrawBlendMode(Renderer, SDL_BLENDMODE_BLEND);
while(running==true)
{
	Events();
	if(MMode!=4)
	Tim=GameTable.CalcTime();
	RenderScreen();
	SDL_Delay(16);
	
}

}
